char *helpstring=""
"This is Monte Carlo code which automatically follows a given phase boundary.\n"
"\n"
"Input files: (see maps documentation)\n"
"  lat.in         (describes the lattice)\n"
"  gs_str.out     (lists the ground states)\n"
"  eci.out        (ECI)\n"
"  clusters.out    (clusters)\n"
"\n"
"You have to provide, on the command line, the following parameters:\n"
"\n"
"-The two phases which are in equilibrium.\n"
"  For instance,\n"
"    -gs1=0 -gs2=1\n"
"  If there are n ground states, phases are numbered from 0 to n-1 .\n"
"  These ground states are read in from gs_str.out\n"
"  The disordered state is labelled by the number -1.\n"
"\n"
"  If the two phases are on different lattices, you need to specify\n"
"  the path that give access to the files \n"
"    lat.in\n"
"    gs_str.out\n"
"    eci.out\n"
"    clusters.out\n"
"  for each lattice. For instance\n"
"   -d1=../fcc/ -d2=../hcp/\n"
"  If either or both options are omitted, the files are read from the\n"
"  current directory.\n"
"  \n"
"-The starting temperature and chemical potential\n"
"  for instance,\n"
"  -T=100 -mu=0.125\n"
"  (Make sure to set blotzmann's constant appropriately.)\n"
"  (If you tracing the phase boundary between two ordered phases, starting from\n"
"  0K, you do not need to specify a starting T and mu.)\n"
"\n"
"-The temperature step\n"
"  for instance -dT=50\n"
"\n"
"-The 'enclosed radius', which sets the system size\n"
"  for instance, -er=35\n"
"  (see emc2 documentation for more information)\n"
"\n"
"-The precision of the calculation\n"
" This is expressed as the desired precision of the average concentration.\n"
"  For instance, -dx=1e-3\n"
" The code automatically finds the equilibration time and the number\n"
" Monte Carlo steps needed to obtain the target standard deviation\n"
" of the average concentration.\n"
"\n"
"There are a number of optional parameters as well.\n"
"\n"
" -ltep: The low temperature expansion is used to find the free energy\n"
"  at low temperature. -ltep gives the maximum error allowed before\n"
"  Monte Carlo is used instead of LTE.\n"
"\n"
" -dmu: The step in chemical potential used when scanning in search\n"
"  of the phase boundary.\n"
"  for instance, -dmu=0.005\n"
"  Sometimes, the algorithm looses track of the phase boundary\n"
"  (because of statistical errors). When that happens, it scans\n"
"  a range of values of the chemical potential in search of the\n"
"  boudary of the hysteresis loop associated with the first\n"
"  order transition of interest. It then position itself in the\n"
"  middle of it. dmu is the step size used for that search.\n"
"  Note that the code will automatically shrink dmu if needed.\n"
"  By default, dmu is automaticaly set to the formation energy\n"
"  of a disordered alloy times 0.01.\n"
"\n"
"  -mug lets you specify a small difference in chemical potential \n"
"  between the phases, to make the code less sensitive to accidental\n"
"  phase transition.\n"
"\n"
"  -k sets boltzman's constant (see emc2 documentation)\n"
"  -keV\n"
"\n"
"  -dn indicates that the boundary must be folowed downward\n"
"   (decreasing  T)\n"
"\n"
"Output file:\n"
"\n"
"  Column      Value\n"
"  1           temperature\n"
"  2           chemical potential\n"
"  3           concentration of phase 1 in [-1,1]\n"
"  4           concentration of phase 2 in [-1,1]\n"
"  5           energy of phase 1\n"
"  6           energy of phase 2\n"
;
